"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const HandlerTree_1 = require("ts-api-decorators/dist/transformer/HandlerTree");
const TransformerMetadata_1 = require("ts-api-decorators/dist/transformer/TransformerMetadata");
const NArgReducer_1 = require("./NArgReducer");
class RouteReducer {
    static reduceFunctionRoutesByPath(api) {
        // TODO: Actually check on the binding triggers and parameter types for each method
        const reducer = new NArgReducer_1.NArgReducer();
        for (const route of HandlerTree_1.WalkTreeByType(api.tree, HandlerTree_1.isHandlerNode)) {
            let methodType = TransformerMetadata_1.getMetadataValueByDescriptor(route.metadata, TransformerMetadata_1.BuiltinMetadata.ApiMethodType);
            if (!methodType) {
                throw new Error(`Unknown http method type: ${methodType}`);
            }
            reducer.add([methodType, route.route], route);
        }
        return reducer.getReduced();
    }
}
exports.RouteReducer = RouteReducer;
//# sourceMappingURL=RouteReducer.js.map