/// <reference types="node" />
import { Context } from "@azure/functions";
import { ManagedApi as BaseManagedApi, ApiHeadersDict, IApiInvocationParams, IApiInvocationResult } from 'ts-api-decorators';
import { AzureFunctionHandlerFunc, IAzureFunctionsTimer } from "./AzureFunctionTypes";
import { IAzureStorageBlobProperties } from "../decorators";
import { IApiProcessor } from "ts-api-decorators/dist/apiManagement/ApiProcessing/ApiProcessing";
export declare function registerApiProcessorsOnHandler(handlerMethod: object, processors: IApiProcessor<IApiInvocationParams<IAzureFunctionManagedApiContext> | IApiInvocationResult>[]): void;
export interface IAzureFunctionManagedApiContext {
    context: Context;
    timer?: IAzureFunctionsTimer;
    inputBlob?: Buffer;
    inputBlobProps?: IAzureStorageBlobProperties;
}
export interface IAzureFunctionTriggerDescriptor {
    triggerType: string;
    route: string;
    methods: string[];
}
export declare class ManagedApi extends BaseManagedApi<IAzureFunctionManagedApiContext> {
    private static readonly SINGLETON_KEY;
    private initialized;
    private handlers;
    private constructor();
    private static GetSingleton;
    static AzureTrigger(descr: IAzureFunctionTriggerDescriptor): AzureFunctionHandlerFunc;
    static getHeadersObject(headers: ApiHeadersDict): {
        [header: string]: string;
    };
    private getHandler;
    private resolveInvocationParamsForContext;
    private init;
    private getHandlerWrapper;
    setHeader(name: string, value: string): void;
}
