import { Command } from 'commander';
import { CliCommand } from 'ts-api-decorators/dist/command/CliCommand';
import { IParseOptions } from 'ts-api-decorators/dist/command/ProgramOptions';
export interface IAzureFunctionGenerateCommandOptions extends IParseOptions {
    outDir: string;
    silent: boolean;
    verbose: boolean;
    httpPrefix?: string;
}
export interface IAzureFunctionGenerateCommandAdditionalOpts {
    alternateLibIncludePath?: string;
}
export declare class AzureFunctionGenerateCommand extends CliCommand {
    private readonly program;
    private readonly additionalOpts?;
    private static readonly HttpPrefixNoneStr;
    private apiParser;
    constructor(program: Command, additionalOpts?: IAzureFunctionGenerateCommandAdditionalOpts);
    protected runCommand(options: IAzureFunctionGenerateCommandOptions): Promise<void>;
    private printSummary;
    protected validateProgramOutputType(value: string, defaultValue: string): string;
}
