"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const ts_api_decorators_1 = require("ts-api-decorators");
const InternalTypes_1 = require("ts-api-decorators/dist/apiManagement/InternalTypes");
const DecoratorUtil_1 = require("ts-api-decorators/dist/decorators/DecoratorUtil");
const HandlerMethodModifierDecorator_1 = require("ts-api-decorators/dist/transformer/HandlerMethodModifierDecorator");
const HandlerMethodParameterDecorator_1 = require("ts-api-decorators/dist/transformer/HandlerMethodParameterDecorator");
const HandlerMethodDecorator_1 = require("ts-api-decorators/dist/transformer/HandlerMethodDecorator");
const AzFuncMetadata_1 = require("../../../metadata/AzFuncMetadata");
const ArgumentExtractors_1 = require("./ArgumentExtractors");
const AzFuncExtension_1 = require("../../../metadata/AzFuncExtension");
const ArgumentExtractors_2 = require("../../ArgumentExtractors");
class BlobStorageMethodDecorators {
    static AzFuncBlob(path, connection) {
        return (target, propertyKey, descriptor) => {
            ts_api_decorators_1.ManagedApiInternal.AddApiMetadataToObject({
                method: "blobTrigger" /* BlobTrigger */,
                route: (connection || '') + path,
                handlerKey: propertyKey,
                handler: descriptor.value,
            }, target.constructor);
        };
    }
}
__decorate([
    DecoratorUtil_1.ApiDecorator(HandlerMethodDecorator_1.HandlerMethodDecorator, {
        indexTs: __filename,
        dependencies: [DecoratorUtil_1.DecoratorParentNameDependency(ts_api_decorators_1.Api.name)],
        provider: AzFuncMetadata_1.AzFuncMetadata.Component,
        arguments: [
            ArgumentExtractors_1.BlobStorageArgumentExtractors.PathArgument,
            ArgumentExtractors_1.BlobStorageArgumentExtractors.ConnectionArgument,
        ],
        metadata: [
            ...AzFuncMetadata_1.AzFuncMetadata.ExtensionBundleMetadata(AzFuncExtension_1.AzFuncExtension.AzureStorage),
            ...AzFuncMetadata_1.AzFuncMetadata.ApiMethodMetadataForBinding("blobTrigger" /* BlobTrigger */),
        ],
    })
], BlobStorageMethodDecorators, "AzFuncBlob", null);
class BlobStorageParams {
    static AzFuncBlobParam(a) {
        return (target, propertyKey, parameterIndex) => {
            const args = a;
            ts_api_decorators_1.ManagedApiInternal.AddApiHandlerParamMetadataToObject({
                args,
                parameterIndex,
                propertyKey,
                type: 6 /* Transport */,
                transportTypeId: BlobStorageParams.TransportTypeBlobInputParam,
            }, target.constructor);
        };
    }
    // public static AzFuncBlobPropertiesParam(path: string, connection?: string): ParameterDecorator;
    static AzFuncBlobPropertiesParam(a) {
        return (target, propertyKey, parameterIndex) => {
            const args = a;
            ts_api_decorators_1.ManagedApiInternal.AddApiHandlerParamMetadataToObject({
                args,
                parameterIndex,
                propertyKey,
                type: 6 /* Transport */,
                transportTypeId: BlobStorageParams.TransportTypeBlobInputPropsParam,
            }, target.constructor);
        };
    }
    static AzFuncBlobOutput(a) {
        return (target, propertyKey, descriptor) => {
            // const args = <IAzFunctionArgs>a;
            // ManagedApiInternal.AddApiModifierMetadataToObject(
            // 	{
            // 		propertyKey,
            // 		arguments: args,
            // 		metadata: AzFuncMetadata.Output,
            // 	}, target.constructor);
        };
    }
}
BlobStorageParams.TransportTypeBlobInputParam = 'inputBlob';
BlobStorageParams.TransportTypeBlobInputPropsParam = 'inputBlobProps';
BlobStorageParams.TransportTypeBlobOutputParam = 'outputblob';
__decorate([
    DecoratorUtil_1.ApiDecorator(HandlerMethodParameterDecorator_1.HandlerMethodParameterDecorator, {
        indexTs: __filename,
        // TODO: If called with the argument-less overlaod then this must be called under `BlobStorageMethodDecorators.AzFuncBlob.name`,
        // but if using the (path, connection) overload then it doesn't have that dependency
        dependencies: [
            (node) => {
                // TODO: how to get the argument count here?
                if (false /* if args.length === 0 */) {
                    return [
                        DecoratorUtil_1.DecoratorParentNameDependency(BlobStorageMethodDecorators.AzFuncBlob.name)
                    ];
                }
            },
        ],
        parameterType: 6 /* Transport */,
        parameterTypeRestrictions: [
            InternalTypes_1.InternalTypeUtil.TypeBuffer,
        ],
        provider: AzFuncMetadata_1.AzFuncMetadata.Component,
        arguments: [
            Object.assign(Object.assign({}, ArgumentExtractors_1.BlobStorageArgumentExtractors.PathArgument), { optional: true }),
            ArgumentExtractors_1.BlobStorageArgumentExtractors.ConnectionArgument,
        ],
        transportTypeId: BlobStorageParams.TransportTypeBlobInputParam,
        transformArgumentsToObject: true,
    })
], BlobStorageParams, "AzFuncBlobParam", null);
__decorate([
    DecoratorUtil_1.ApiDecorator(HandlerMethodParameterDecorator_1.HandlerMethodParameterDecorator, {
        indexTs: __filename,
        // TODO: If called with the argument-less overlaod then this must be called under `BlobStorageMethodDecorators.AzFuncBlob.name`,
        // but if using the (path, connection) overload then it doesn't have that dependency
        dependencies: [
            (node) => {
                // TODO: how to get the argument count here?
                if (false /* if args.length === 0 */) {
                    return [
                        DecoratorUtil_1.DecoratorParentNameDependency(BlobStorageMethodDecorators.AzFuncBlob.name)
                    ];
                }
            },
        ],
        parameterType: 6 /* Transport */,
        parameterTypeRestrictions: [
            InternalTypes_1.InternalTypeUtil.TypeAnyObject,
        ],
        provider: AzFuncMetadata_1.AzFuncMetadata.Component,
        arguments: [
            Object.assign(Object.assign({}, ArgumentExtractors_1.BlobStorageArgumentExtractors.PathArgument), { optional: true }),
            ArgumentExtractors_1.BlobStorageArgumentExtractors.ConnectionArgument,
        ],
        transportTypeId: BlobStorageParams.TransportTypeBlobInputPropsParam,
        transformArgumentsToObject: true,
    })
], BlobStorageParams, "AzFuncBlobPropertiesParam", null);
__decorate([
    DecoratorUtil_1.ApiDecorator(HandlerMethodModifierDecorator_1.HandlerMethodModifierDecorator, {
        indexTs: __filename,
        dependencies: [],
        provider: AzFuncMetadata_1.AzFuncMetadata.Component,
        arguments: [
            ArgumentExtractors_2.AzFuncArgumentExtractors.OutParamArgument,
            Object.assign(Object.assign({}, ArgumentExtractors_1.BlobStorageArgumentExtractors.PathArgument), { optional: true }),
            ArgumentExtractors_1.BlobStorageArgumentExtractors.ConnectionArgument,
        ],
        transformArgumentsToObject: true,
        metadata: [
            AzFuncMetadata_1.AzFuncMetadata.OutputMetadata(BlobStorageParams.TransportTypeBlobOutputParam),
            ...AzFuncMetadata_1.AzFuncMetadata.ExtensionBundleMetadata(AzFuncExtension_1.AzFuncExtension.AzureStorage),
        ],
    })
], BlobStorageParams, "AzFuncBlobOutput", null);
exports.BlobStorageParams = BlobStorageParams;
exports.AzFuncBlobMethodDecorator = DecoratorUtil_1.ApiMethodDecoratorGetFunction(BlobStorageMethodDecorators);
exports.AzFuncBlobParamDecorator = DecoratorUtil_1.ApiMethodDecoratorGetFunction(BlobStorageParams);
exports.AzFuncBlobModifierDecorator = DecoratorUtil_1.ApiMethodDecoratorGetFunction(BlobStorageParams);
exports.AzFuncBlob = BlobStorageMethodDecorators.AzFuncBlob;
exports.AzFuncBlobParam = BlobStorageParams.AzFuncBlobParam;
exports.AzFuncBlobPropertiesParam = BlobStorageParams.AzFuncBlobPropertiesParam;
exports.AzFuncBlobOutput = BlobStorageParams.AzFuncBlobOutput;
//# sourceMappingURL=BlobStorageTrigger.js.map