"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const ts_api_decorators_1 = require("ts-api-decorators");
const InternalTypes_1 = require("ts-api-decorators/dist/apiManagement/InternalTypes");
const DecoratorUtil_1 = require("ts-api-decorators/dist/decorators/DecoratorUtil");
const HandlerMethodParameterDecorator_1 = require("ts-api-decorators/dist/transformer/HandlerMethodParameterDecorator");
const HandlerMethodDecorator_1 = require("ts-api-decorators/dist/transformer/HandlerMethodDecorator");
const AzFuncMetadata_1 = require("../../../metadata/AzFuncMetadata");
const ArgumentExtractors_1 = require("./ArgumentExtractors");
const TransformerMetadata_1 = require("ts-api-decorators/dist/transformer/TransformerMetadata");
class TimerTriggerMethodDecorators {
    static AzFuncTimerTrigger() {
        return (target, propertyKey, descriptor) => {
            ts_api_decorators_1.ManagedApiInternal.AddApiMetadataToObject({
                method: "timerTrigger" /* TimerTrigger */,
                route: "timerTrigger" /* TimerTrigger */,
                handlerKey: propertyKey,
                handler: descriptor.value,
            }, target.constructor);
        };
    }
}
__decorate([
    DecoratorUtil_1.ApiDecorator(HandlerMethodDecorator_1.HandlerMethodDecorator, {
        indexTs: __filename,
        dependencies: [DecoratorUtil_1.DecoratorParentNameDependency(ts_api_decorators_1.Api.name)],
        provider: AzFuncMetadata_1.AzFuncMetadata.Component,
        arguments: [
            ArgumentExtractors_1.TimerArgumentExtractors.ScheduleArgument,
            ArgumentExtractors_1.TimerArgumentExtractors.RunOnStartupArgument,
            ArgumentExtractors_1.TimerArgumentExtractors.UseMonitorArgument,
        ],
        metadata: [
            Object.assign(Object.assign({}, TransformerMetadata_1.BuiltinMetadata.Route), { value: "timerTrigger" /* TimerTrigger */ }),
            ...AzFuncMetadata_1.AzFuncMetadata.ApiMethodMetadataForBinding("timerTrigger" /* TimerTrigger */),
        ],
    })
], TimerTriggerMethodDecorators, "AzFuncTimerTrigger", null);
class TimerTriggerParams {
    static AzFuncTimerParam(a) {
        return (target, propertyKey, parameterIndex) => {
            const args = a;
            ts_api_decorators_1.ManagedApiInternal.AddApiHandlerParamMetadataToObject({
                args,
                parameterIndex,
                propertyKey,
                type: 6 /* Transport */,
                transportTypeId: TimerTriggerParams.TransportTypeTimerParam,
            }, target.constructor);
        };
    }
}
TimerTriggerParams.TransportTypeTimerParam = 'timer';
__decorate([
    DecoratorUtil_1.ApiDecorator(HandlerMethodParameterDecorator_1.HandlerMethodParameterDecorator, {
        indexTs: __filename,
        dependencies: [DecoratorUtil_1.DecoratorParentNameDependency(TimerTriggerMethodDecorators.AzFuncTimerTrigger.name)],
        parameterType: 6 /* Transport */,
        parameterTypeRestrictions: [
            InternalTypes_1.InternalTypeUtil.TypeAnyObject,
        ],
        provider: AzFuncMetadata_1.AzFuncMetadata.Component,
        arguments: [],
        transportTypeId: TimerTriggerParams.TransportTypeTimerParam,
    })
], TimerTriggerParams, "AzFuncTimerParam", null);
exports.AzFuncTimerMethodDecorator = DecoratorUtil_1.ApiMethodDecoratorGetFunction(TimerTriggerMethodDecorators);
exports.AzFuncTimerParamDecorator = DecoratorUtil_1.ApiMethodDecoratorGetFunction(TimerTriggerParams);
exports.AzFuncTimerTrigger = TimerTriggerMethodDecorators.AzFuncTimerTrigger;
exports.AzFuncTimerParam = TimerTriggerParams.AzFuncTimerParam;
//# sourceMappingURL=TimerTrigger.js.map