import { IGenerator, OutputFileGeneratorFunc } from 'ts-api-decorators/dist/generators/IGenerator';
import { ParsedCommandLine } from 'typescript';
import { IBindingTrigger, IBindingParam } from '../Bindings';
import { IHandlerTreeNode, IHandlerTreeNodeHandler } from 'ts-api-decorators/dist/transformer/HandlerTree';
export interface IFunctionFileGeneratorOpts {
    tsConfig?: ParsedCommandLine;
    tsConfigPath?: string;
    triggers: IBindingTrigger[];
    params: IBindingParam[];
    libIncludePath?: string;
}
export declare class FunctionFileGenerator implements IGenerator {
    private opts;
    private static readonly LIB_INCLUDE;
    static readonly FILE_NAME = "index.js";
    private static readonly TEMPLATE_NAME;
    private readonly mustacheGenerator;
    private readonly triggers;
    private readonly params;
    constructor(opts: IFunctionFileGeneratorOpts);
    forTree(routes: IHandlerTreeNode[]): OutputFileGeneratorFunc;
    private getLibIncludePath;
    getSourceFilesForRoutes(routes: IHandlerTreeNodeHandler[], p: string): string[];
    private getScriptFilePathGenerator;
    getFilenameForFunction(functionName: string): string;
    private getRoute;
    private getTriggerTypeForRoutes;
    private getTriggerType;
}
