import { IGenerator, OutputFileGeneratorFunc } from 'ts-api-decorators/dist/generators/IGenerator';
import { IBinding, IBindingParam, IBindingTrigger } from '../Bindings';
import { ParsedCommandLine } from 'typescript';
import { IHandlerTreeNode } from 'ts-api-decorators/dist/transformer/HandlerTree';
export interface IFunctionJson {
    bindings: IBinding[];
    scriptFile: string;
}
export interface IFunctionHostJsonFileGeneratorOpts {
    setWatchDirectories?: boolean;
    tsConfig?: ParsedCommandLine;
    tsConfigPath?: string;
    triggers: IBindingTrigger[];
    params: IBindingParam[];
    extensionOpts?: IFunctionHostFile['extensions'];
}
export interface IFunctionJsonHttpExtensionOpts {
    routePrefix?: string;
    maxOutstandingRequests?: number;
    maxConcurrentRequests?: number;
    dynamicThrottlesEnabled?: boolean;
    hsts?: {
        isEnabled: boolean;
        maxAge: string;
    };
    customHeaders?: {
        [key: string]: string;
    };
}
interface IFunctionHostFile {
    version: string;
    watchDirectories?: string[];
    extensionBundle?: {
        id: string;
        version: string;
    };
    extensions?: {
        http?: IFunctionJsonHttpExtensionOpts;
    };
}
export declare class FunctionHostFileGenerator implements IGenerator {
    private readonly opts;
    static readonly FILE_NAME = "host.json";
    private static readonly DEFAULT_FUNCTIONS_VERSION;
    private static readonly JSON_PRETTY_PRINT_SPACE;
    private readonly triggers;
    private readonly params;
    constructor(opts: IFunctionHostJsonFileGeneratorOpts);
    forTree(routes: IHandlerTreeNode[]): OutputFileGeneratorFunc;
    private generateHostJson;
    private getExtensionsForRoutes;
    private addExtensionIds;
    private getWatchedDirectories;
    private getRelativePathOfOutputDirectory;
    getFilename(): string;
}
export {};
