import { IGenerator, OutputFileGeneratorFunc } from 'ts-api-decorators/dist/generators/IGenerator';
import { IBinding, IBindingParam, IBindingTrigger, IBindingOutput } from '../Bindings';
import { IHandlerTreeNode } from 'ts-api-decorators/dist/transformer/HandlerTree';
export interface IFunctionJson {
    bindings: IBinding[];
    scriptFile: string;
}
export interface IFunctionJsonFileGeneratorOpts {
    triggers: IBindingTrigger[];
    params: IBindingParam[];
    outputs: IBindingOutput[];
}
export declare class FunctionJsonFileGenerator implements IGenerator {
    static readonly FILE_NAME = "function.json";
    private static readonly JSON_PRETTY_PRINT_SPACE;
    private readonly triggers;
    private readonly params;
    private readonly outputs;
    constructor(opts: IFunctionJsonFileGeneratorOpts);
    forTree(routes: IHandlerTreeNode[]): OutputFileGeneratorFunc;
    private generateRouteStr;
    private generateRoutes;
    private getParamBindings;
    private getTriggerType;
    getFilenameForFunction(functionName: string): string;
}
