import { AzFuncBinding } from "./AzFuncBindings";
export interface IAzureFunctionExtensionInformation {
    id: string;
    version: string;
}
export interface IAzureFunctionExtensionDefinition extends IAzureFunctionExtensionInformation {
    name?: string;
    bindings?: AzFuncBinding[];
}
export declare abstract class AzFuncExtension {
    static GetExtensionForId(idStr: string): IAzureFunctionExtensionDefinition | undefined;
    static GetExtensionForBinding(binding: AzFuncBinding): IAzureFunctionExtensionDefinition | undefined;
    static IsTriggerTypeBinding(binding: AzFuncBinding): boolean;
    static readonly ExtensionBundle: IAzureFunctionExtensionDefinition;
    static readonly AzureStorage: IAzureFunctionExtensionDefinition;
    static readonly ServiceBus: IAzureFunctionExtensionDefinition;
    static readonly EventHubs: IAzureFunctionExtensionDefinition;
    static readonly SendGrid: IAzureFunctionExtensionDefinition;
    static readonly DurableTask: IAzureFunctionExtensionDefinition;
    static readonly EventGrid: IAzureFunctionExtensionDefinition;
    static readonly CosmosDB: IAzureFunctionExtensionDefinition;
    static readonly Twilio: IAzureFunctionExtensionDefinition;
    static readonly SignalRService: IAzureFunctionExtensionDefinition;
    private static readonly _Extensions;
    private static readonly _BuiltinBindings;
    private static readonly _TriggerBindings;
}
