import { IMetadataDescriptor, ITransformerMetadata } from "ts-api-decorators/dist/transformer/TransformerMetadata";
import { IAzureFunctionExtensionDefinition } from "./AzFuncExtension";
import { AzFuncBinding } from "./AzFuncBindings";
import { __ApiParamArgs } from "ts-api-decorators/dist/apiManagement/InternalTypes";
export interface IAzFunctionArgs extends __ApiParamArgs {
    azfextensionbundle?: string;
    azftimerschedule?: string;
    azftimerrunonstartup?: string;
    azftimerusermonitor?: string;
    azfblobstorconn?: string;
    azfbindingoutfield?: string;
    azfbindingoutput?: string;
}
export interface IAzFunctionMetadataDescriptor extends IMetadataDescriptor {
    key?: keyof IAzFunctionArgs;
}
export declare abstract class AzFuncMetadata {
    static readonly Component = "ts-api-decorators-azure-function";
    static readonly ExtensionBundle: IAzFunctionMetadataDescriptor;
    static readonly TimerSchedule: IAzFunctionMetadataDescriptor;
    static readonly TimerRunOnStartup: IAzFunctionMetadataDescriptor;
    static readonly TimerUseMonitor: IAzFunctionMetadataDescriptor;
    static readonly BlobStorageConnection: IAzFunctionMetadataDescriptor;
    static readonly OutField: IAzFunctionMetadataDescriptor;
    static readonly Output: IAzFunctionMetadataDescriptor;
    static OutputMetadata(transportTypeId: string): ITransformerMetadata;
    static ExtensionBundleMetadata(extension: IAzureFunctionExtensionDefinition): ITransformerMetadata[];
    static ApiMethodMetadataForBinding(binding: AzFuncBinding): ITransformerMetadata[];
}
