"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const TransformerMetadata_1 = require("ts-api-decorators/dist/transformer/TransformerMetadata");
const AzFuncExtension_1 = require("./AzFuncExtension");
class AzFuncMetadata {
    static OutputMetadata(transportTypeId) {
        return Object.assign(Object.assign({}, AzFuncMetadata.Output), { value: transportTypeId });
    }
    static ExtensionBundleMetadata(extension) {
        return [
            Object.assign(Object.assign({}, AzFuncMetadata.ExtensionBundle), { value: extension.id })
        ];
    }
    static ApiMethodMetadataForBinding(binding) {
        if (!AzFuncExtension_1.AzFuncExtension.IsTriggerTypeBinding(binding)) {
            throw new Error(`Cannot get API method for non-trigger-type binding: ${binding}`);
        }
        return [
            Object.assign(Object.assign({}, TransformerMetadata_1.BuiltinMetadata.ApiMethod), { value: binding }),
            Object.assign(Object.assign({}, TransformerMetadata_1.BuiltinMetadata.ApiMethodType), { value: binding }),
        ];
    }
}
exports.AzFuncMetadata = AzFuncMetadata;
AzFuncMetadata.Component = 'ts-api-decorators-azure-function';
AzFuncMetadata.ExtensionBundle = {
    type: "Plugin" /* Plugin */,
    component: AzFuncMetadata.Component,
    key: 'azfextensionbundle',
};
AzFuncMetadata.TimerSchedule = {
    type: "Plugin" /* Plugin */,
    component: AzFuncMetadata.Component,
    key: 'azftimerschedule',
};
AzFuncMetadata.TimerRunOnStartup = {
    type: "Plugin" /* Plugin */,
    component: AzFuncMetadata.Component,
    key: 'azftimerrunonstartup',
};
AzFuncMetadata.TimerUseMonitor = {
    type: "Plugin" /* Plugin */,
    component: AzFuncMetadata.Component,
    key: 'azftimerusermonitor',
};
AzFuncMetadata.BlobStorageConnection = {
    type: "Plugin" /* Plugin */,
    component: AzFuncMetadata.Component,
    key: 'azfblobstorconn',
};
AzFuncMetadata.OutField = {
    type: "Plugin" /* Plugin */,
    component: AzFuncMetadata.Component,
    key: 'azfbindingoutfield',
};
AzFuncMetadata.Output = {
    type: "Plugin" /* Plugin */,
    component: AzFuncMetadata.Component,
    key: 'azfbindingoutput',
};
//# sourceMappingURL=AzFuncMetadata.js.map