"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const transformer_1 = require("ts-api-decorators/dist/transformer");
const DecoratorResolver_1 = require("ts-api-decorators/dist/transformer/DecoratorResolver");
const decorators_1 = require("./decorators");
const TimerTrigger_1 = require("./decorators/ExtensionDecorators/TimerTrigger/TimerTrigger");
const BlobStorageTrigger_1 = require("./decorators/ExtensionDecorators/BlobStorage/BlobStorageTrigger");
function getTransformerArguments() {
    const decoratorResolver = new DecoratorResolver_1.DecoratorResolver([
        decorators_1.AzFuncParamDecorator(decorators_1.AzFuncApiRequestParam),
        decorators_1.AzFuncParamDecorator(decorators_1.AzFuncApiResponseParam),
        TimerTrigger_1.AzFuncTimerMethodDecorator(decorators_1.AzFuncTimerTrigger),
        TimerTrigger_1.AzFuncTimerParamDecorator(decorators_1.AzFuncTimerParam),
        BlobStorageTrigger_1.AzFuncBlobMethodDecorator(BlobStorageTrigger_1.AzFuncBlob),
        BlobStorageTrigger_1.AzFuncBlobParamDecorator(BlobStorageTrigger_1.AzFuncBlobParam),
        BlobStorageTrigger_1.AzFuncBlobParamDecorator(BlobStorageTrigger_1.AzFuncBlobPropertiesParam),
        BlobStorageTrigger_1.AzFuncBlobModifierDecorator(BlobStorageTrigger_1.AzFuncBlobOutput),
    ]);
    transformer_1.registerDefaultDecorators(decoratorResolver);
    return {
        decoratorResolver,
        registerBuiltindecorators: false,
    };
}
exports.getTransformerArguments = getTransformerArguments;
function azFuncTransformer(program) {
    return transformer_1.default(program, getTransformerArguments());
}
exports.default = azFuncTransformer;
//# sourceMappingURL=transformer.js.map